package zero1hd.rhythmbullet.audio.visualizer;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;

public class MirrorVisualizer {
	private int xPos, yPos;
	private float rotation;
	private Sprite[] bars;
	private boolean flip;
	
	private Vector2 rectCoordRot;
	public MirrorVisualizer() {
		rectCoordRot = new Vector2();
	}
	
	protected void setup(Sprite[] bars, float xPos, float yPos, float rotation) {
		this.bars = new Sprite[bars.length];
		this.xPos = (int) xPos;
		this.yPos = (int) yPos;
		this.rotation = rotation;
		rectCoordRot.set(MathUtils.cosDeg(rotation), MathUtils.sinDeg(rotation));

		for (int i = 0; i < bars.length; i++) {
			this.bars[i] = new Sprite(bars[i]);
		}
	}
	
	public void render(int renderID, Batch batch, float parentAlpha, Sprite[] bars) {
		this.bars[renderID].setSize(bars[renderID].getWidth(), bars[renderID].getHeight());
		this.bars[renderID].draw(batch);
	}
	
	public void position(int barWidth, int spaceBetweenBars, boolean shrink) {
		int barSpaceMultiplier = barWidth + spaceBetweenBars;

		for (int i = 0; i < bars.length; i ++) {
			if (flip) {
				bars[i].setRotation(rotation+180);
			} else {
				bars[i].setRotation(rotation);
			}
			int barSpace = i*(barWidth+spaceBetweenBars);
			if (i == bars.length-1 && shrink) {
				barSpace -= 2;
			}
			bars[i].setPosition(xPos + barSpace*rectCoordRot.x, yPos + barSpace*rectCoordRot.y);
		}
	}
	
	public void setColor(Color color) {
		for (int i = 0; i < bars.length; i++) {
			bars[i].setColor(color);
		}
	}
	
	public void setColor(float r, float g, float b, float a) {
		for (int i = 0; i < bars.length; i++) {
			bars[i].setColor(r, g, b, a);
		}
	}
	
	public float getRotation() {
		return rotation;
	}
	
	public void setRotation(float rotation) {
		this.rotation = rotation;
	}
	
	public void setyPos(int yPos) {
		this.yPos = yPos;
	}
	
	public void setxPos(int xPos) {
		this.xPos = xPos;
	}

}
