package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;

public class ShortenedTextLabel extends Label {
	private String originalText;
	private int targetWidth;
	
	public ShortenedTextLabel(CharSequence text, Skin skin, String fontName, Color color) {
		super(text, skin, fontName, color);
		originalText = text.toString();
	}
	
	public void setTargetWidth(int targetWidth) {
		this.targetWidth = targetWidth;
		validate();
	}
	
	@Override
	public void act(float delta) {
		if (getGlyphLayout().width > targetWidth && getText().length - 4 > 0) {
			setText(getText().substring(0, getText().length - 4).concat("..."));
			validate();
		}
		super.act(delta);
	}
	
	public void setToOriginalText() {
		setText(originalText);
	}
	
	@Override
	public void layout() {
		super.layout();
	}
	
	public void setOriginalText(String originalText) {
		this.originalText = originalText;
	}
}
